routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');
Route::view('/', 'welcome', ['name' => 'Prueba'])->name('welcome');

Route::resource('alumno', 'AlumnoController');
Route::resource('user', 'UserController');
Route::resource('empresa', 'EmpresaController');
Route::resource('centro', 'CentroController');
Route::resource('contacto', 'ContactoController');
Route::resource('oferta', 'OfertaController');
Route::resource('inscripcion', 'InscripcionController');

Route::get('download/{id}/{pdf}', 'DownloadController@download');

app/Contacto.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Contacto extends Model
{
    protected $table = 'contactos';
    protected $fillable = [
        'empresa_id',
        'nombre',
        'tlf',
        'email',
    ];

    public function empresa()
    {
        return $this->belongsTo('App\Empresa');
    }

    public function ofertas()
    {
        return $this->hasMany('App\Oferta');
    }
}

app/Http/Controllers/ContactoController.php
<?php

namespace App\Http\Controllers;

use App\Contacto;
use App\Empresa;
use App\Functions;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class ContactoController extends Controller
{

    public function __construct(){
        $this->middleware('auth');
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        if (Functions::setValidRole(['empresa'])) {
            $contactos = Contacto::all()->where('empresa_id', Auth::user()->empresa['id']);
        } else if (Functions::setValidRole(['profesor'])) {
            $contactos = Contacto::all();
        } else{
            return abort(404);
        }
        if (!$contactos) { return abort(404); }
        return view('contacto.index', compact('contactos'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        if (Functions::setValidRole(['profesor'])) {
            $empresas = Empresa::all();
            $arrayEmpresas = null;
            foreach ($empresas as $empresa) {
                $arrayEmpresas[$empresa->id] = $empresa->user['name'];
            }
            return view('contacto.create', compact('arrayEmpresas'));
        } else if (Functions::setValidRole(['alumno'])) {
            return abort(404);
        }
        return view('contacto.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        if (Functions::setValidRole(['alumno'])) {
            return abort(404);
        }
        $data = $request->all();

        if (!$data) { return abort(404); }

        Contacto::create([
            'empresa_id' => isset($data['empresa_id']) ? $data['empresa_id'] : Auth::user()->empresa['id'],
            'nombre' => $data['nombre'],
            'tlf' => $data['tlf'],
            'email' => $data['email'],
        ]);

        return redirect()->route('contacto.index')->with('info', 'Contacto creado');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Contacto  $contacto
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $contacto = Contacto::find($id);
        if (!$contacto) { return abort(404); }
        if (Functions::setValidRole(['empresa']) && !Functions::setValidId($contacto->empresa->id)) {
            return abort(404);
        }
        return view('contacto.show', compact('contacto'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Contacto  $contacto
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $contacto = Contacto::find($id);
        if (!$contacto) { return abort(404); }
        if (Functions::setValidRole(['empresa', 'alumno']) && !Functions::setValidId($contacto->empresa->id)) {
            return abort(404);
        }
        if (Functions::setValidRole(['profesor'])) {
            $empresas = Empresa::all();
            $arrayEmpresas = null;
            foreach ($empresas as $empresa) {
                $arrayEmpresas[$empresa->id] = $empresa->user['name'];
            }
            return view('contacto.edit', compact('arrayEmpresas', 'contacto'));
        }
        return view('contacto.edit', compact('contacto'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Contacto  $contacto
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $contacto = Contacto::find($id);
        $data = $request->all();
        if (!$contacto || !$data) { return abort(404); }
        if (Functions::setValidRole(['empresa', 'alumno']) && !Functions::setValidId($contacto->empresa->id)) {
            return abort(404);
        }
        $contacto->fill($data)->save();
        return redirect()->route('contacto.index')->with('info', 'Contacto actualizado');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Contacto  $contacto
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $contacto = Contacto::find($id);
        if (!$contacto) { return abort(404); }
        if (Functions::setValidRole(['empresa', 'alumno']) && !Functions::setValidId($contacto->empresa->id)) {
            return abort(404);
        }
        $contacto->delete();
        return redirect()->route('contacto.index')->with('info', 'Contacto eliminado');
    }
}

resources/views/contacto/create.blade.php
@extends('layouts.app')

@section('content')
<form method="POST" action="{{ route('contacto.store') }}">
  @csrf
  @include('contacto.partials.form')

  <div class="box-footer">
	  {{ Form::submit('Crear', ['class' => 'btn btn-primary btn-block']) }}
	</div>
</form>
@endsection

resources/views/contacto/edit.blade.php
@extends('layouts.app')

@section('content')
{{ Form::model($contacto, ['route' => ['contacto.update', $contacto], 'method' => 'PUT', 'files' => false]) }}
  @include('contacto.partials.form')
<div>
  {{ Form::submit('Actualizar', ['class' => 'btn btn-primary btn-block']) }}
</div>
{{ Form::close() }}
@endsection

resources/views/contacto/index.blade.php
@extends('layouts.app')

@section('content')
<table class="table table-bordered table-hover" id="example1">
	<thead>
		<tr>
			<th>Empresa</th>
			<th>Nombre</th>
			<th>Teléfono</th>
			<th>Email</th>
			<th class="text-center" data-orderable="false">Ver</th><th class="text-center" data-orderable="false">Editar</th><th class="text-center" data-orderable="false">Borrar</th>
		</tr>
	</thead>
	<tbody>
	@foreach ($contactos as $contacto)
		<tr>
			<td>{{ $contacto->empresa->user['name'] }}</td>
			<td>{{ $contacto->nombre }}</td>
			<td>{{ $contacto->tlf }}</td>
			<td>{{ $contacto->email }}</td>
			<td class="text-center">
				<a href="{{ route('contacto.show', $contacto) }}" class="btn btn-info">
				<svg class="bi bi-eye-fill text-white" width="1.25em" height="1.25em" viewBox="0 0 16 16" fill="currentColor" xmlns="http://www.w3.org/2000/svg" style="display:inline-block;">
				    <path d="M10.5 8a2.5 2.5 0 1 1-5 0 2.5 2.5 0 0 1 5 0z"/>
				    <path fill-rule="evenodd" d="M0 8s3-5.5 8-5.5S16 8 16 8s-3 5.5-8 5.5S0 8 0 8zm8 3.5a3.5 3.5 0 1 0 0-7 3.5 3.5 0 0 0 0 7z"/>
				</svg>
				</a>
				</td>
			<td class="text-center">
				<a href="{{ route('contacto.edit', $contacto) }}" class="btn btn-success">
				<svg class="bi bi-pencil text-white" width="1.25em" height="1.25em" viewBox="0 0 16 16" fill="currentColor" xmlns="http://www.w3.org/2000/svg" style="display:inline-block;">
				  <path fill-rule="evenodd" d="M11.293 1.293a1 1 0 0 1 1.414 0l2 2a1 1 0 0 1 0 1.414l-9 9a1 1 0 0 1-.39.242l-3 1a1 1 0 0 1-1.266-1.265l1-3a1 1 0 0 1 .242-.391l9-9zM12 2l2 2-9 9-3 1 1-3 9-9z"/>
				  <path fill-rule="evenodd" d="M12.146 6.354l-2.5-2.5.708-.708 2.5 2.5-.707.708zM3 10v.5a.5.5 0 0 0 .5.5H4v.5a.5.5 0 0 0 .5.5H5v.5a.5.5 0 0 0 .5.5H6v-1.5a.5.5 0 0 0-.5-.5H5v-.5a.5.5 0 0 0-.5-.5H3z"/>
				</svg>
				</a>
				</td>
			<td class="text-center">
				{!! Form::open(['route' => ['contacto.destroy', $contacto], 'method' => 'DELETE']) !!}
				<button class="btn btn-danger" onclick="return confirm('Eliminar este contacto borrará todas las ofertas asociadas a él ¿Estás seguro?')">
					<svg class="bi bi-trash-fill" width="1.2em" height="1.2em" viewBox="0 0 16 16" fill="currentColor" xmlns="http://www.w3.org/2000/svg">
					  <path fill-rule="evenodd" d="M2.5 1a1 1 0 0 0-1 1v1a1 1 0 0 0 1 1H3v9a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V4h.5a1 1 0 0 0 1-1V2a1 1 0 0 0-1-1H10a1 1 0 0 0-1-1H7a1 1 0 0 0-1 1H2.5zm3 4a.5.5 0 0 1 .5.5v7a.5.5 0 0 1-1 0v-7a.5.5 0 0 1 .5-.5zM8 5a.5.5 0 0 1 .5.5v7a.5.5 0 0 1-1 0v-7A.5.5 0 0 1 8 5zm3 .5a.5.5 0 0 0-1 0v7a.5.5 0 0 0 1 0v-7z"/>
					</svg>
				</button>
				{!! Form::close() !!}
			</td>
		</tr>
	@endforeach
	</tbody>
</table>
<a href="{{ route('contacto.create') }}">
<svg class="bi bi-plus-circle-fill text-secondary" width="3em" height="3em" viewBox="0 0 16 16" fill="currentColor" xmlns="http://www.w3.org/2000/svg" style="display:block;margin:auto;">
<path fill-rule="evenodd" d="M16 8A8 8 0 1 1 0 8a8 8 0 0 1 16 0zM8.5 4a.5.5 0 0 0-1 0v3.5H4a.5.5 0 0 0 0 1h3.5V12a.5.5 0 0 0 1 0V8.5H12a.5.5 0 0 0 0-1H8.5V4z"/>
</svg>
</a>
@endsection
@section('scripts')
<script src="https://cdn.datatables.net/1.10.21/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.21/js/dataTables.bootstrap4.min.js"></script>
<script>
  jQuery(function($) {
    $('#example1').DataTable({
    	"order": [[ 1, "desc" ]],
    	"columnDefs": [
                    {
                        "targets": [ 4, 5, 6 ],
                        "visible": true,
                        "searchable": false
                    },
        ],
    	"language": {
    		"zeroRecords": "Nada que mostrar",
            "info": "Mostrando _START_ a _END_ de _TOTAL_ contactos",
            "infoEmpty": "No hay datos disponibles",
            "infoFiltered": "(filtrados de _MAX_ contactos en total)",
            "sLengthMenu": "Mostrar _MENU_ contactos",
            "paginate": {
      			"previous": "Anterior",
      			"next": "Siguiente"
    		}
        }
    });
  });
</script>
@endsection

resources/views/contacto/show.blade.php
@extends('layouts.app')

@section('content')
<h2>Contacto</h2>
<div class="list-group">
  <a href="{{ route('empresa.show', $contacto->empresa->id) }}" class="list-group-item list-group-item-action text-primary">Empresa: {{ $contacto->empresa->user['name'] }}</a>
  <a href="#" class="list-group-item list-group-item-action disabled">Nombre: {{ $contacto->nombre }}</a>
  <a href="#" class="list-group-item list-group-item-action disabled">Teléfono: {{ $contacto->tlf }}</a>
  <a href="mailto:{{ $contacto->email }}" class="list-group-item list-group-item-action disabled">Email: {{ $contacto->email }}</a>
  @if ((Auth::user()->empresa['id_fiscal'] && Auth::user()->empresa['id'] == $contacto->empresa->id))
	<a href="{{ route('contacto.edit', $contacto->id) }}" class="btn btn-success btn-block">Editar</a>
  @endif
</div>
<a class="btn btn-secondary btn-block mt-4" href="{{ URL::previous() }}">Volver</a>
@endsection